import { Component, h, Prop, State } from '@stencil/core';
import { randomIdGenerator } from '../../../global/utils/randomIdGenerator';

@Component({
  tag: 'digi-icon-language-outline',
  styleUrl: 'icon-language-outline.scss',
  scoped: true
})
export class IconLanguageOutline {
  /**
   * Lägger till ett titleelement i svg:n
   * @en Adds a title element inside the svg
   */
  @Prop() afTitle: string;

  /**
   * Lägger till ett descelement i svg:n
   * @en Adds a desc element inside the svg
   */
  @Prop() afDesc: string;

  /**
   * För att dölja ikonen för skärmläsare. Default är satt till true.
   * @en Hides the icon for screen readers. Default is set to true.
   */
  @Prop() afSvgAriaHidden = true;

  /**
   * Referera till andra element på sidan för att definiera ett tillgängligt namn.
   * @en Reference other elements on the page to define an accessible name.
   */
  @Prop() afSvgAriaLabelledby: string;

  @State() titleId: string = randomIdGenerator('icontitle');

  render() {
    return (
      <svg
        class="digi-icon-language-outline"
        width="48"
        height="48"
        viewBox="0 0 48 48"
        xmlns="http://www.w3.org/2000/svg"
        aria-hidden={this.afSvgAriaHidden ? 'true' : 'false'}
        aria-labelledby={
          this.afSvgAriaLabelledby
            ? this.afSvgAriaLabelledby
            : this.afTitle
              ? this.titleId
              : undefined
        }>
        {this.afTitle && <title id={this.titleId}>{this.afTitle}</title>}
        {this.afDesc && <desc>{this.afDesc}</desc>}
        <path
          class="digi-icon-language-outline__shape"
          d="M36.04,13.76 C36.90151,13.76 37.6,14.4584906 37.6,15.3200013 L37.6,17.9200034 L46.44,17.9200034 C47.30151,17.9200034 48,18.618494 48,19.4800047 L48,20.5200055 C48,21.3815163 47.30151,22.0800068 46.44,22.0800068 L44.39913,22.0800068 C43.42348,25.3042695 41.35297,28.7024723 38.56265,31.8094748 C39.86434,32.9902658 41.2244,34.0539267 42.58277,34.9406574 C43.27333,35.3913678 43.49108,36.3024085 43.08197,37.0183191 L42.56366,37.9251998 C42.11789,38.7053305 41.10922,38.9449207 40.35457,38.4570303 C38.64572,37.3520294 37.05309,36.0862183 35.60177,34.7520272 C34.07505,36.1110483 32.41599,37.3710094 30.66281,38.4804303 C29.91388,38.9544107 28.91964,38.7011705 28.47998,37.9316998 L27.96362,37.0281991 C27.54801,36.3009785 27.78435,35.3808377 28.49116,34.9314274 C29.97082,33.9906166 31.37976,32.9257857 32.68236,31.7819148 C31.37898,30.3165536 30.25513,28.8488524 29.34305,27.4876213 C28.84476,26.7438907 29.06875,25.7352198 29.83744,25.2763195 L30.73015,24.743449 C31.44112,24.3191287 32.36165,24.5223188 32.82211,25.2104094 C33.65138,26.4494404 34.60558,27.6735214 35.64012,28.8443024 C37.59233,26.6427506 39.11385,24.3066487 40.00149,22.0800068 L24.6,22.0800068 C23.73849,22.0800068 23.04,21.3815163 23.04,20.5200055 L23.04,19.4800047 C23.04,18.618494 23.73849,17.9200034 24.6,17.9200034 L33.44,17.9200034 L33.44,15.3200013 C33.44,14.4584906 34.13849,13.76 35,13.76 L36.04,13.76 Z M11.8332182,8 C12.4533144,8 13.0104128,8.41979192 13.2613189,9.06143216 L13.3103093,9.20225 L21.0298359,34.40225 C21.3740964,35.52617 20.6914083,36.70193 19.6807365,36.7941925 L19.5527448,36.8 L18.2035404,36.8 C17.5726564,36.8 17.0082304,36.3657029 16.7636848,35.7078609 L16.7162706,35.56355 L14.9535225,29.4176 L6.16653372,29.4176 L4.40378559,35.56355 C4.20626245,36.2522788 3.67070856,36.7324658 3.0505984,36.7934298 L2.9165158,36.8 L1.56718092,36.8 C0.530390624,36.8 -0.207539483,35.6691968 0.0524708867,34.5427952 L0.0902203595,34.4021 L7.80974695,9.2021 C8.01571171,8.5298323 8.54519248,8.06530164 9.15501959,8.00635208 L9.28683801,8 L11.8332182,8 Z M10.6357215,13.2363636 L10.56,13.2363636 L10.3621159,14.1932684 L10.3621159,14.1932684 L10.0354099,15.6696863 L10.0354099,15.6696863 L9.83948374,16.4932089 L9.83948374,16.4932089 L9.68546438,17.1021936 L9.68546438,17.1021936 L9.5294815,17.6774822 L9.5294815,17.6774822 L9.42445743,18.0364336 L7.04,26.3272727 L14.08,26.3272727 L11.6955426,18.0364336 C11.6069862,17.7222208 11.5159719,17.3656023 11.4262538,16.9920247 L11.2496581,16.2297971 L11.2496581,16.2297971 L10.9967588,15.0570068 L10.9967588,15.0570068 L10.6357215,13.2363636 L10.6357215,13.2363636 Z"
          fill="currentColor"
          fill-rule="nonzero"
        />
      </svg>
    );
  }
}
